Index: typo3/sysext/rtehtmlarea/htmlarea/htmlarea-ie.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/htmlarea-ie.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/htmlarea-ie.js	(copie de travail)
@@ -3,7 +3,7 @@
 *
 *  (c) 2002-2004 interactivetools.com, inc.
 *  (c) 2003-2004 dynarch.com
-*  (c) 2004-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2004-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -35,7 +35,7 @@
 /***************************************************
  *  IE-SPECIFIC FUNCTIONS
  ***************************************************/
-HTMLArea.prototype.isEditable = function() {
+HTMLArea.Editor.prototype.isEditable = function() {
 	return this._doc.body.contentEditable;
 };
 
@@ -45,14 +45,14 @@
 /*
  * Get the current selection object
  */
-HTMLArea.prototype._getSelection = function() {
+HTMLArea.Editor.prototype._getSelection = function() {
 	return this._doc.selection;
 };
 
 /*
  * Create a range for the current selection
  */
-HTMLArea.prototype._createRange = function(sel) {
+HTMLArea.Editor.prototype._createRange = function(sel) {
 	if (typeof(sel) == "undefined") {
 		var sel = this._getSelection();
 	}
@@ -65,7 +65,7 @@
 /*
  * Select a node AND the contents inside the node
  */
-HTMLArea.prototype.selectNode = function(node) {
+HTMLArea.Editor.prototype.selectNode = function(node) {
 	this.focusEditor();
 	this.forceRedraw();
 	var range = this._doc.body.createTextRange();
@@ -76,7 +76,7 @@
 /*
  * Select ONLY the contents inside the given node
  */
-HTMLArea.prototype.selectNodeContents = function(node, endPoint) {
+HTMLArea.Editor.prototype.selectNodeContents = function(node, endPoint) {
 	this.focusEditor();
 	this.forceRedraw();
 	var range = this._doc.body.createTextRange();
@@ -90,7 +90,7 @@
 /*
  * Determine whether the node intersects the range
  */
-HTMLArea.prototype.rangeIntersectsNode = function(range, node) {
+HTMLArea.Editor.prototype.rangeIntersectsNode = function(range, node) {
 	this.focusEditor();
 	var nodeRange = this._doc.body.createTextRange();
 	nodeRange.moveToElementText(node);
@@ -101,7 +101,7 @@
 /*
  * Retrieve the HTML contents of selected block
  */
-HTMLArea.prototype.getSelectedHTML = function() {
+HTMLArea.Editor.prototype.getSelectedHTML = function() {
 	var sel = this._getSelection();
 	var range = this._createRange(sel);
 	if (sel.type.toLowerCase() == "control") {
@@ -116,7 +116,7 @@
 /*
  * Retrieve simply HTML contents of the selected block, IE ignoring control ranges
  */
-HTMLArea.prototype.getSelectedHTMLContents = function() {
+HTMLArea.Editor.prototype.getSelectedHTMLContents = function() {
 	var sel = this._getSelection();
 	var range = this._createRange(sel);
 	return range.htmlText;
@@ -125,7 +125,7 @@
 /*
  * Get the deepest node that contains both endpoints of the current selection.
  */
-HTMLArea.prototype.getParentElement = function(selection, range) {
+HTMLArea.Editor.prototype.getParentElement = function(selection, range) {
 	if (!selection) {
 		var selection = this._getSelection();
 	}
@@ -150,7 +150,7 @@
  * @returns null | element
  * Borrowed from Xinha (is not htmlArea) - http://xinha.gogo.co.nz/
  */
-HTMLArea.prototype._activeElement = function(sel) {
+HTMLArea.Editor.prototype._activeElement = function(sel) {
 	if (sel == null) {
 		return null;
 	}
@@ -172,7 +172,7 @@
 /*
  * Determine if the current selection is empty or not.
  */
-HTMLArea.prototype._selectionEmpty = function(selection) {
+HTMLArea.Editor.prototype._selectionEmpty = function(selection) {
 	if (!selection || selection.type.toLowerCase() === "none") return true;
 	if (selection.type.toLowerCase() === "text") {
 		return !this._createRange(selection).text;
@@ -183,14 +183,14 @@
 /*
  * Get a bookmark
  */
-HTMLArea.prototype.getBookmark = function (range) {
+HTMLArea.Editor.prototype.getBookmark = function (range) {
 	return range.getBookmark();
 };
 
 /*
  * Move the range to the bookmark
  */
-HTMLArea.prototype.moveToBookmark = function (bookmark) {
+HTMLArea.Editor.prototype.moveToBookmark = function (bookmark) {
 	var range = this._createRange();
 	range.moveToBookmark(bookmark);
 	return range;
@@ -199,7 +199,7 @@
 /*
  * Select range
  */
-HTMLArea.prototype.selectRange = function (range) {
+HTMLArea.Editor.prototype.selectRange = function (range) {
 	range.select();
 };
 /***************************************************
@@ -211,7 +211,7 @@
  * Delete the current selection, if any.
  * Split the text node, if needed.
  */
-HTMLArea.prototype.insertNodeAtSelection = function(toBeInserted) {
+HTMLArea.Editor.prototype.insertNodeAtSelection = function(toBeInserted) {
 	this.insertHTML(toBeInserted.outerHTML);
 };
 
@@ -219,7 +219,7 @@
  * Insert HTML source code at the current position.
  * Delete the current selection, if any.
  */
-HTMLArea.prototype.insertHTML = function(html) {
+HTMLArea.Editor.prototype.insertHTML = function(html) {
 	var sel = this._getSelection();
 	if (sel.type.toLowerCase() == "control") {
 		sel.clear();
@@ -238,7 +238,7 @@
  *
  * @return	void
  */
-HTMLArea.prototype.wrapWithInlineElement = function(element, selection, range) {
+HTMLArea.Editor.prototype.wrapWithInlineElement = function(element, selection, range) {
 	var nodeName = element.nodeName;
 	var parent = this.getParentElement(selection, range);
 	var bookmark = this.getBookmark(range);
@@ -312,7 +312,7 @@
 /*
  * Handle the backspace event in IE browsers
  */
-HTMLArea.prototype._checkBackspace = function() {
+HTMLArea.Editor.prototype._checkBackspace = function() {
 	var selection = this._getSelection();
 	var range = this._createRange(selection);
 	if (selection.type == "Control"){ // Deleting or backspacing on a control selection : delete the element
Index: typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js	(copie de travail)
@@ -3,7 +3,7 @@
 *
 *  (c) 2002-2004 interactivetools.com, inc.
 *  (c) 2003-2004 dynarch.com
-*  (c) 2004-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2004-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -33,46 +33,22 @@
  *
  * TYPO3 SVN ID: $Id$
  */
-
+	// Avoid re-starting on Ajax request
+if (typeof(HTMLArea) == 'undefined') {
+	// Establish HTMLArea name space
+Ext.namespace('HTMLArea.util.TYPO3', 'HTMLArea.util.Tips', 'HTMLArea.util.Color', 'Ext.ux.form', 'Ext.ux.menu', 'Ext.ux.Toolbar');
 /***************************************************
- *  EDITOR INITIALIZATION AND CONFIGURATION
+ *  BROWSER IDENTIFICATION
  ***************************************************/
-	// Avoid re-starting on Ajax request
-if (typeof(HTMLArea) != "function") {
-
-/*
- * HTMLArea object constructor.
- */
-HTMLArea = function(textarea, config) {
-	if (HTMLArea.checkSupportedBrowser()) {
-		if (typeof(config) == "undefined") this.config = new HTMLArea.Config();
-			else this.config = config;
-		this._htmlArea = null;
-		this._textArea = textarea;
-		if (typeof(this._textArea) == "string") {
-			this._textArea = HTMLArea.getElementById("textarea", this._textArea);
-		}
-		this.plugins = {};
-		this._timerToolbar = null;
-		this.doctype = '';
-		this.eventHandlers = {};
-	}
-};
-
-/*
- * Browser identification
- */
 HTMLArea.agt = navigator.userAgent.toLowerCase();
-HTMLArea.is_opera  = (HTMLArea.agt.indexOf("opera") != -1);
+HTMLArea.is_opera  = Ext.isOpera;
 // Some operations require bug fixes provided by Opera 10 (Presto 2.2)
-HTMLArea.is_opera9 = HTMLArea.is_opera && HTMLArea.agt.indexOf("Presto/2.1") != -1;
-HTMLArea.is_ie = (HTMLArea.agt.indexOf("msie") != -1) && !HTMLArea.is_opera;
-HTMLArea.is_safari = (HTMLArea.agt.indexOf("webkit") != -1);
-HTMLArea.is_gecko  = (navigator.product == "Gecko") || HTMLArea.is_opera;
-HTMLArea.is_ff2 = (HTMLArea.agt.indexOf("firefox/2") != -1);
-HTMLArea.is_chrome = HTMLArea.is_safari && (HTMLArea.agt.indexOf("chrome") != -1);
-// Check on MacOS Wamcom version 1.3, if Mozilla will check earliest supported build in checkSupportedBrowser()
-HTMLArea.is_wamcom = (HTMLArea.agt.indexOf("wamcom") != -1) || (HTMLArea.is_gecko && HTMLArea.agt.indexOf("rv:1.3") != -1);
+HTMLArea.is_opera9 = Ext.isOpera && HTMLArea.agt.indexOf("Presto/2.1") != -1;
+HTMLArea.is_ie = Ext.isIE;
+HTMLArea.is_safari = Ext.isWebKit;
+HTMLArea.is_gecko  = Ext.isGecko || Ext.isOpera || Ext.isWebKit;
+HTMLArea.is_ff2 = Ext.isGecko2;
+HTMLArea.is_chrome = Ext.isChrome;
 
 /*
  * A log for troubleshooting
@@ -86,7 +62,9 @@
 		}
 	}
 };
-
+/***************************************************
+ *  SCRIPTS LOADING PROCESS
+ ***************************************************/
 /*
  * Build stack of scripts to be loaded
  */
@@ -97,7 +75,7 @@
 	if (typeof(asynchronous) == "undefined") {
 		var asynchronous = true;
 	}
-	if (HTMLArea.is_opera) url = _typo3_host_url + url;
+	if (Ext.isOpera) url = _typo3_host_url + url;
 	if (HTMLArea._compressedScripts && url.indexOf("compressed") == -1) url = url.replace(/\.js$/gi, "_compressed.js");
 	var scriptInfo = {
 		pluginName	: pluginName,
@@ -202,8 +180,6 @@
 		if (typeof(_editor_edited_content_CSS) != "string") _editor_edited_content_CSS = _editor_skin + "htmlarea-edited-content.css";
 		if (typeof(_editor_lang) == "string") _editor_lang = _editor_lang ? _editor_lang.toLowerCase() : "en";
 		HTMLArea.editorCSS = _editor_CSS;
-			// Initialize event cache
-		HTMLArea._eventCache = HTMLArea._eventCacheConstructor();
 			// Initialize pending request flag
 		HTMLArea.pendingSynchronousXMLHttpRequest = false;
 			// Set troubleshooting mode
@@ -220,8 +196,8 @@
 		HTMLArea._scripts = [];
 		HTMLArea._scriptLoaded = [];
 		HTMLArea._request = [];
-		if (HTMLArea.is_gecko) HTMLArea.loadScript(RTEarea[0]["htmlarea-gecko"] ? RTEarea[0]["htmlarea-gecko"] : _editor_url + "htmlarea-gecko.js");
-		if (HTMLArea.is_ie) HTMLArea.loadScript(RTEarea[0]["htmlarea-ie"] ? RTEarea[0]["htmlarea-ie"] : _editor_url + "htmlarea-ie.js");
+		if (!Ext.isIE) HTMLArea.loadScript(RTEarea[0]["htmlarea-gecko"] ? RTEarea[0]["htmlarea-gecko"] : _editor_url + "htmlarea-gecko.js");
+		if (Ext.isIE) HTMLArea.loadScript(RTEarea[0]["htmlarea-ie"] ? RTEarea[0]["htmlarea-ie"] : _editor_url + "htmlarea-ie.js");
 		for (var i = 0, n = HTMLArea_plugins.length; i < n; i++) {
 			HTMLArea.loadScript(HTMLArea_plugins[i].url, "", HTMLArea_plugins[i].asynchronous);
 		}
@@ -247,10 +223,10 @@
 			if (success) {
 				HTMLArea.checkInitialLoad();
 			} else {
-				if (HTMLArea.is_ie) window.setTimeout('alert(HTMLArea.I18N.msg["ActiveX-required"]);', 200);
+				if (Ext.isIE) window.setTimeout('alert(HTMLArea.I18N.msg["ActiveX-required"]);', 200);
 			}
 		} else {
-			if (HTMLArea.is_ie) alert(HTMLArea.I18N.msg["ActiveX-required"]);
+			if (Ext.isIE) alert(HTMLArea.I18N.msg["ActiveX-required"]);
 		}
 	}
 };
@@ -259,25 +235,17 @@
  * Compile some regular expressions
  */
 HTMLArea.RE_tagName = /(<\/|<)\s*([^ \t\n>]+)/ig;
-HTMLArea.RE_doctype = /(<!doctype((.|\n)*?)>)\n?/i;
 HTMLArea.RE_head    = /<head>((.|\n)*?)<\/head>/i;
 HTMLArea.RE_body    = /<body>((.|\n)*?)<\/body>/i;
 HTMLArea.Reg_body = new RegExp("<\/?(body)[^>]*>", "gi");
 HTMLArea.reservedClassNames = /htmlarea/;
 HTMLArea.RE_email    = /([0-9a-z]+([a-z0-9_-]*[0-9a-z])*){1}(\.[0-9a-z]+([a-z0-9_-]*[0-9a-z])*)*@([0-9a-z]+([a-z0-9_-]*[0-9a-z])*\.)+[a-z]{2,9}/i;
 HTMLArea.RE_url      = /(https?:\/\/)?(([a-z0-9_]+:[a-z0-9_]+@)?[a-z0-9_-]{2,}(\.[a-z0-9_-]{2,})+\.[a-z]{2,5}(:[0-9]+)?(\/\S+)*)/i;
-
-/*
- * Editor configuration object constructor
- */
-
-HTMLArea.Config = function () {
-	this.width = "auto";
-	this.height = "auto";
-		// whether the toolbar should be included in the size or not.
-	this.sizeIncludesToolbar = true;
-		// if true then HTMLArea will retrieve the full HTML, starting with the <HTML> tag.
-	this.fullPage = false;
+/***************************************************
+ *  EDITOR CONFIGURATION
+ ***************************************************/
+HTMLArea.Config = function (editorId) {
+	this.editorId = editorId;
 		// if the site is secure, create a secure iframe
 	this.useHTTPS = false;
 		// for Mozilla
@@ -300,7 +268,9 @@
 	this.customTags = null;
 		// BaseURL included in the iframe document
 	this.baseURL = document.baseURI || document.URL;
-	if(this.baseURL && this.baseURL.match(/(.*)\/([^\/]+)/)) this.baseURL = RegExp.$1 + "/";
+	if (this.baseURL && this.baseURL.match(/(.*)\/([^\/]+)/)) {
+		this.baseURL = RegExp.$1 + "/";
+	}
 		// URL-s
 	this.imgURL = "images/";
 	this.popupURL = "popups/";
